#!/usr/bin/env python
# --
# Copyright (c) 2004 Felix Schwarz <felix@schwarz-online.org>
# --
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. For
# details, see http://www.gnu.org/licenses/gpl.txt.
# --
# Author(s):
#   Felix Schwarz < felix@schwarz-online.org >
# --

# This program is currently more or less a proof of concept.
# TODO:
# - get the filename from the command line
# - be more robust and catch all types of exceptions
# - handle the case that there are multiple urls with the same filename
# - refactor the methods so that they are less than 10 lines long


import zipfile, re, urllib, os


filenameRemotePictures = "Existenzgrndung.sxw"

# -------------------------------------------------------------------------

def renameOriginal(filename):
	filenameRegex = re.compile("^(.*)\.(.+?)$")
	match = filenameRegex.search(filename)
	newFilename = match.group(1) + ".bak." + match.group(2)
        os.rename(filename,newFilename)
        return newFilename


def convertToSXWName(filename):
	return "Pictures/" + filename

def embedRemoteImages(zip, filedata):
	urlRegex = re.compile("<draw:image[^>]+?xlink:href=\"(http://.*?)\"")
	filenameRegex = re.compile("^.*\/(.*?)$")
	remoteImages = {}
	for url in urlRegex.findall(filedata):
		filename = filenameRegex.match(url).group(1)

		tempname = filename
		if url not in remoteImages:
			print "fetching "+url
			remoteImages[url] = tempname
			filehandle = urllib.urlopen(url)
			downloadedImage = filehandle.read()
			filehandle.close()

			sxwName = convertToSXWName(tempname)
			filedata = filedata.replace(url, "#"+sxwName)
			zip.writestr(sxwName, downloadedImage)
		else: print "skipping " + url

	return filedata

# -------------------------------------------------------------------------

filenameLocalPictures = filenameRemotePictures
filenameRemotePictures = renameOriginal(filenameRemotePictures)

file = zipfile.ZipFile(filenameRemotePictures, "r")
fileWithLocalPictures = zipfile.ZipFile("temporaer.zip", "w")

contentXML = None

# copy files to another new zip file
# this is due to the fact that there is no 'remove' option within the python zipfile module
# there is a bug if the same name exists more than one time in the zip archive because
# the compressed files are selected only by name. Therefore only the first matching file
# will be duplicated x times.
for name in file.namelist():
    filecontent = file.read(name)

    if name == 'content.xml':
    	contentXML = filecontent
    else: fileWithLocalPictures.writestr(name, filecontent)


contentXML = embedRemoteImages(fileWithLocalPictures, contentXML)
fileWithLocalPictures.writestr('content.xml', contentXML)

file.close()
fileWithLocalPictures.close()

print "finished"

os.rename ("temporaer.zip", filenameLocalPictures)

